<script setup lang="ts">
import QRScanner from '@/components/QRScanner.vue'
import API from '@/scripts/api'
import { useDataStore } from '@/store/data'
import { useSessionStore } from '@/store/session'
import { onMounted, reactive } from 'vue'
import { useRoute } from 'vue-router'

const data = useDataStore()
const session = useSessionStore()

const route = useRoute()
const ticketFromRoute = (route.query.id && route.query.code)
  ? { id: parseInt(route.query.id.toString()), code: route.query.code.toString() }
  : null

const ticketStr = localStorage.getItem('ticket')
const ticketFromLocalStorage = ticketStr ? JSON.parse(ticketStr) : null

const state = reactive({
  tempTicket: data.ticket ?? ticketFromLocalStorage ?? ticketFromRoute ?? null as ({ id: number, code: string } | null),
  loading: false
})

function onScan(value: string) {
  try {
    const scannedValues = value.slice(value.indexOf('?') + 1).split('&').map(pair => pair.split('='))

    let id: number | null = null
    let code: string | null = null

    for (const pair of scannedValues) {
      const k = pair[0]
      const v = pair[1]
      if (k === 'id') id = parseInt(v)
      else if (k === 'code') code = v
    }

    if (!id || !code) throw Error('id or code missing in URL')
    state.tempTicket = { id, code }
    saveCode()
  } catch (e) {
    console.log('Unable to decode URL: ', e)
  }
}

function clearCode() {
  if (!state.tempTicket) return
  if (!session.isActive) {
    state.tempTicket = null
  } else {
    state.loading = true
    API.unbindTicketSelf().then(() => {
      state.tempTicket = null
    }).finally(() => {
      state.loading = false
    })
  }
}

onMounted(() => {
  if (ticketFromRoute != null && ticketFromLocalStorage == null) {
    localStorage.setItem('ticket', JSON.stringify(state.tempTicket))
  }

  // if logged in and ticket not bound (back from tequila with already a ticket)
  if (state.tempTicket && !data.ticket?.bound && session.isActive) {
    saveCode()
  }
})

function saveCode() {
  if (!state.tempTicket) return

  state.loading = true
  const { id, code } = state.tempTicket
  if (!session.isActive) {
    API.tequilaRequest().finally(() => {
      // noop // keep the loading animation for the (slow) redirection
    })
  } else {
    API.bindTicketSelf(session.sciper as string, id, code).catch(() => {
      state.tempTicket = null
    }).finally(() => {
      localStorage.removeItem('ticket')
      state.loading = false
    })
  }
}

</script>

<template>
  <div class="h-full flex flex-col justify-between px-3 max-w-lg mx-auto lg:max-h-96">
    <div>
      <div class="text-2xl font-bold mb-1">Bienvenue sur AGEVoté !</div>
      <div class="font-italic text-sm ml-3 mb-3">Activation du ticket de présence</div>
    </div>

    <!-- Scanner or logo depending on ticket existance in state-->
    <div class="flex justify-center p-3">
      <div id="logo-container" v-if="state.tempTicket">
        <v-img src="@/assets/agevote-logo-round.png" width="300" />
      </div>
      <q-r-scanner v-else @scan="onScan" />
    </div>

    <!-- Button waiting for scan if we don't have a ticket in state -->
    <div v-if="!state.tempTicket" class="flex flex-col justify-between mb-3">
      <v-btn disabled size="x-large" variant="flat" class="mb-2">
        <v-icon icon="mdi-qrcode-scan" size="large" start />
        En attente du scan...
      </v-btn>
    </div>

    <!-- We have the ticket and ... -->
    <div v-if="state.tempTicket">
      <!-- .. it isn't bound yet : we need to login -->
      <div v-if="!data.ticket?.bound && !session.isActive" class="flex flex-col justify-between mb-3">
        <h3 class="text-lg text-center my-3">Vous avez scanné le <b>ticket n°{{ state.tempTicket.id }}</b></h3>
        <v-btn size="x-large" variant="outlined" color="primary" class="mb-6" @click="saveCode" :loading="state.loading">
          <v-icon icon="mdi-qrcode-scan" size="large" start />
          Connexion Tequila
        </v-btn>

        <v-btn variant="text" @click="clearCode">
          <v-icon icon="mdi-refresh" size="large" start />
          Nouveau scan
        </v-btn>
      </div>

      <!-- .. we are back from Tequila, pending activation ... -->
      <div v-if="!data.ticket?.bound && session.isActive" class="flex h-full justify-center items-center">
        <v-progress-circular color="grey" indeterminate :size="128" :width="12"></v-progress-circular>
      </div>

      <!-- .. it is already bound -->
      <div v-if="data.ticket?.bound" class="flex flex-col justify-between mb-3">
        <v-alert
          icon="mdi-qrcode-scan"
          :title="`Ticket n°${data.ticket.id} enregistré`"
          variant="tonal"
          color="success"
          class="mb-10"
        />
        <v-btn link to="/votes" class="mt-3 mb-5" color="primary">Retour aux votes</v-btn>
        <v-btn variant="text" @click="clearCode">
          <v-icon icon="mdi-refresh" size="large" start color="error" variant="tonal" :loading="state.loading" />
          Annuler le ticket
        </v-btn>
        <p><b>NB</b> : un ticket annulé n'est plus utilisable. Échangez-le auprès d'un agent de présence si vous souhaitez encore voter.</p>
      </div>
    </div>

  </div>
</template>

<style scoped>
#logo-container {
  max-width: 50vw;
}
</style>
